module Logger::Logging
  class ExtendedLogger < ::Logger
    def format_severity severity
      case severity
      when -1 then "TRACE"
      when -2 then "DATA"
      else super
      end
    end

    def trace message_or_progname = nil, &block
      add -1, nil, message_or_progname, &block
    end

    def data message_or_progname = nil, &block
      if block_given?
        progname = message_or_progname
        message = yield
      else
        message = message_or_progname
      end

      message.each_line "\n" do |line|
        if line == "\n"
          line = "\\n"
        else
          line.gsub! "\r", "\\r"
          line.chomp!
        end

        add -2, nil, line
      end
    end

    def io
      @logdev and @logdev.dev
    end
  end
end
